#!/bin/sh
# $Id: t-tls.sh,v 1.9 2014/03/04 04:12:34 ca Exp $
# Copyright (c) 2003-2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ------------------------------------------
# test TLS
# ------------------------------------------
#
test -s stop && exit 1
# source directory of this (and other) shell script
SD=`dirname $0`
#
SRV="error.srv"
CLT="error.clt"
# NOTICE: this must be larger than the size of the TCP buffer...
L=1000000
# verbose?
VERBOSE=false
PRG=./t-tls-0
#
OPT="-V"

for i in CAcert.pem smcert.pem smkey.pem
do
  cp ${SD}/../chkmts/${i} .
done
[ -d certs ] || mkdir certs

rm -f ${SRV} ${CLT}
${VERBOSE} && echo "TLS server/client: basic test"
${PRG} -s 100 2> ${SRV} &
sleep 1
${PRG} -c 100 2> ${CLT}
wait
sleep 1

for i in ${SRV} ${CLT}
do
fgrep 'completed successfully' $i || exit 1
fgrep 'errors in test!' $i && exit 1
done


${VERBOSE} || rm -f ${SRV} ${CLT}
exit 0
