#!/bin/sh
# $Id: t-delay-6.sh,v 1.2 2013/11/26 03:09:13 ca Exp $
# Copyright (c) 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test delay DSN and bounce DSN; including text of bounces delivered
# via lmtp to smtps3
# run smtp1.sh with different parameters
# ----------------------------------------
#

if test X"${MTA_NO_SLOW_TEST}" != "X"
then
  echo "SKIPPED: $0: MTA_NO_SLOW_TEST is set"
  exit 0
fi

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

chkcto qmgr MTA_DELAYED_DSN

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
sender: local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}
rm -f ${MTMAP}

# ----------------------------------------
# temporary failure from SMTP sink; create a delay DSN which is undeliverable
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
${CAT} > ${EDBROK} <<EOF
got transaction
	mail=<r551@local.host>
	rcpts_tot=2
	rcpts_left=1
	rcpts_temp=1
	rcpts_perm=1
	state=551
	aqt_rcpts_ar=0
got recipient
	rcpt=<451@local.host>
	aqr_rcpt_idx=0
	aqr_da_idx=0
	aqr_status=451
EOF
if ${SHELL} ${SD}/smtp1.sh -b -O ${EDBROK} -3 lmtpsock -Sr551@local.host -R451@local.host -Q '-F 0 -T w=4' -i 4 -s 20 -E 4 -X 0 -A 1
then
  if test -s ${B1}
  then
    ${VERBOSE} && echo "$0: ${B1} exists"
    ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  rm -f ${EDBROK} ${OK} ${OUT} ${TMP}
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
