#!/bin/sh
# $Id: t-tls-ssf-1.sh,v 1.2 2013/10/20 20:03:44 ca Exp $
#
# ----------------------------------------
# test TLS smtps session features
# ----------------------------------------
#

SD=`dirname $0`
THISDIR=`pwd`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

chkcto smtps MTA_USE_TLS

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

setuptls0

${CAT} > ${ACC} <<EOF
smtps_session_conf:127.0.0.1	session_feature=tls1;
EOF
rm -f ${ACCMAP}
${MM} -t'	' -F ${ACCMAP} < ${ACC}

# ----------------------------------------
# test: use different cert, cipher, and CAlist.
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4; }
smar { Log_Level = 12; nameserver = ${NS}; }
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4; }
smtps {
  flags = {access, lookup_session_conf};
  session_features  tls1 { flags = starttls;
	tls { key_file = sckey.pem; cert_file=sccert.pem; cipherlist=MEDIUM;
          calist_file=C2cert.pem;
        }
  }
Log_Level = 12;
daemon_address = localhost:${SRVPORT};
wait_for_server=4;
}
EOF

if ${SHELL} ${SD}/smtpcnf.sh -F ${SRVPORT} -Ssender2@other.dom -Ruser@host.local -E 1 -X 1 -A 1 -q
then
  if fgrep 'host.example.com' ${CLTL} >/dev/null
  then
    if grep 'Cipher.*AES' ${CLTL} >/dev/null
    then
      # this is a HIGH cipher?
      echo "$0: ${TEST}: found Cipher AES in ${CLTL}"
      ERR=true
    else
      if grep '^Acceptable client certificate CA names' ${CLTL} >/dev/null &&
         grep '^/C=US/ST=California/L=Berkeley/O=Example Com/OU=MTA/CN=CA/emailAddress=CA@example\.com$' ${CLTL} >/dev/null
      then
        :
      else
        echo "$0: ${TEST}: missing client certificate CA names in ${CLTL}"
        ERR=true
      fi
    fi
  else
    echo "$0: ${TEST}: missing host.example.com in ${CLTL}"
    ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

testend
