/*
 * Copyright (c) 2004-2006 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 * $Id: sccnfdef.h,v 1.73 2013/12/28 04:22:50 ca Exp $
 */

#ifndef SM_SCCNFDEF_H
#define SM_SCCNFDEF_H 1

#include "sm/generic.h"
#include "sm/time.h"
#include "sm/qmgrcnf.h"
#include "sm/mta.h"
#include "sm/smtpdef.h"
#include "sm/scdef.h"

#define LMTPSOCK	"lmtpsock"

#if SM_SCCNFDEF
#define SM_CONF_TIME_DEF 1
#define SM_TLSREQCNFDEF 1
#define SM_TLSCNFDEF 1
#endif

#include "sm/sm-conf-time.h"

#include "sm/mcpcnfs.h"
#include "sm/tlsreqcnf.h"
#include "sm/tlsreqcnfs.h"
#include "sm/tlscnfs.h"

#if SM_SCCNFDEF
#define EXTERN
#else
#define EXTERN extern
#endif

#define SC_FLN_READ_QUIT "read_QUIT_reply"
#define SC_FLD_READ_QUIT "read reply to QUIT command"
#define SC_FLN_SEP_DOT_QUIT "separate_final_dot_and_QUIT"
#define SC_FLD_SEP_DOT_QUIT "separate final dot and QUIT"
#define SC_FLN_NOTTM "talk_to_myself"
#define SC_FLD_NOTTM "do not check whether server greets with our own hostname"
#define SC_FLN_STARTTLS "starttls"
#define SC_FLD_STARTTLS "try STARTTLS"
#define SC_FLN_SEP_STATS_TM "timing"
#define SC_FLD_SEP_STATS_TM "collect timing statistics"
#define SC_FLN_RSET "always_RSET"
#define SC_FLD_RSET "always use RSET between transactions"
#define SC_FLN_ALTEV "alt_event_sys"
#define SC_FLD_ALTEV "use alternate event system"

EXTERN
sm_conf_definition_T const
sc_flag_names[]
#if SM_SCCNFDEF
=
{
{ SM_CONF_DEF_MAGIC,
	SC_FLN_READ_QUIT,		sm_conf_type_choice_value,
	SCC_CFL_READ_QUIT,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_READ_QUIT
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_SEP_DOT_QUIT,	sm_conf_type_choice_value,
	SCC_CFL_SEP_DOT_QUIT,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_SEP_DOT_QUIT
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_NOTTM,		sm_conf_type_choice_value,
	SCC_CFL_NOTTM,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_NOTTM
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

/* other flags? see above */
{ SM_CONF_DEF_MAGIC,
	SC_FLN_STARTTLS,			sm_conf_type_choice_value,
	SCC_CFL_STARTTLS,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_STARTTLS
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_SEP_STATS_TM,			sm_conf_type_choice_value,
	SCC_CFL_SEP_STATS_TM,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_SEP_STATS_TM
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_RSET,			sm_conf_type_choice_value,
	SCC_CFL_RSET,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_RSET
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_ALTEV,			sm_conf_type_choice_value,
	SCC_CFL_ALTEV,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_ALTEV
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

CONF_SENTINEL
}
#endif /* SM_SCCNFDEF */
;

#if SC_SESS_FEATS
EXTERN
sm_conf_definition_T const
sc_se_flag_names[]
#if SM_SCCNFDEF
=
{
/* hack to allow for "|" of initialization data and trailing "u" */
{ SM_CONF_DEF_MAGIC, "u|",  sm_conf_type_u32_suffix, 1,
	1, NULL, SM_CONF_FLAG_DONTPRINT, NULL, NULL, NULL, ""
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },
{ SM_CONF_DEF_MAGIC, "|",  sm_conf_type_u32_suffix, 1,
	1, NULL, SM_CONF_FLAG_DONTPRINT, NULL, NULL, NULL, ""
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },
{ SM_CONF_DEF_MAGIC, "u",  sm_conf_type_u32_suffix, 1,
	1, NULL, SM_CONF_FLAG_DONTPRINT, NULL, NULL, NULL, ""
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_READ_QUIT,		sm_conf_type_choice_value,
	SCSE_CFL_READ_QUIT,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_READ_QUIT
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_SEP_DOT_QUIT,	sm_conf_type_choice_value,
	SCSE_CFL_SEP_DOT_QUIT,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_SEP_DOT_QUIT
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_NOTTM,		sm_conf_type_choice_value,
	SCSE_CFL_NOTTM,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_NOTTM
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_STARTTLS,			sm_conf_type_choice_value,
	SCSE_CFL_STARTTLS,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_STARTTLS
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_SEP_STATS_TM,			sm_conf_type_choice_value,
	SCSE_CFL_SEP_STATS_TM,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_SEP_STATS_TM
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC,
	SC_FLN_RSET,			sm_conf_type_choice_value,
	SCSE_CFL_RSET,
	0, NULL, 0, NULL, NULL, NULL,
	SC_FLD_RSET
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

CONF_SENTINEL
}
#endif /* SM_SCCNFDEF */
;

EXTERN
sm_conf_definition_T
sc_se_feat_defs[]
#if SM_SCCNFDEF
=
{
{ SM_CONF_DEF_MAGIC, "name",		sm_conf_type_section_title,
	offsetof(sc_se_feat_T, scsf_name),	0,
	NULL,	0 /*SM_CONF_FLAG_STRICTLY_REQUIRED*/,
	NULL, NULL, NULL, NULL
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },
{ SM_CONF_DEF_MAGIC, "flags",		sm_conf_type_choice,
	offsetof(sc_se_feat_T, scsf_flags),	sizeof(uint32_t),
	SM_XSTR(SCSE_CFL_STARTTLS),
	SM_CONF_FLAG_MULTIPLE|SM_CONF_FLAG_OR|SM_CONF_FLAG_NUMERIC|SM_CONF_FLAG_PLURAL|SM_CONF_FLAG_DEFAULT_FROM_ENVIRONMENT,
	sc_se_flag_names,
	NULL,	NULL,
	"flags to influence behavior per session"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(0) },

#if MTA_USE_TLS
{ SM_CONF_DEF_MAGIC, "tls", sm_conf_type_section,
	offsetof(sc_se_feat_T, scsf_cnf_tls), sizeof(sc_se_feat_T), NULL,
	SM_CONF_FLAG_KEEP_DEFAULT|SM_CONF_FLAG_MULTIPLE|SM_CONF_FLAG_SET0,
	tls_defs,
	NULL, NULL, NULL
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(0) },
#endif /* MTA_USE_TLS */

CONF_SENTINEL
}
#endif /* SM_SCCNFDEF */
;

EXTERN
sm_conf_definition_T
sc_se_feat_definitions[]
#if SM_SCCNFDEF
=
{

{ SM_CONF_DEF_MAGIC, "session feature declaration",	sm_conf_type_section,
	offsetof(sc_cnf_T, sc_cnf_se_feats.scsfs_feat), sizeof(sc_se_feat_T),
	NULL, SM_CONF_FLAG_SECTION_MUST_BE_NAMED,
	sc_se_feat_defs,
	NULL, NULL, NULL
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

{ SM_CONF_DEF_MAGIC, "n",	sm_conf_type_array_n,
	offsetof(sc_cnf_T, sc_cnf_se_feats.scsfs_n), sizeof(uint),
	NULL, 0,
	sc_se_feat_defs,
	NULL, NULL,
	"number of session features (implicit)"
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },

CONF_SENTINEL
}
#endif /* SM_SCCNFDEF */
;
#endif /* SC_SESS_FEATS */

EXTERN
sm_conf_definition_T
sc_defs[]
#if SM_SCCNFDEF
=
{
{ SM_CONF_DEF_MAGIC, "remote_port",			sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_port),	sizeof(int),
	SM_XSTR(SMTPC_PORT),	0,	NULL,	NULL,	NULL,
	"port to connect to on server"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },
{ SM_CONF_DEF_MAGIC, "LMTP_socket",		sm_conf_type_string,
	offsetof(sc_cnf_T, sc_cnf_lmtpsock ),	0,
	LMTPSOCK,	0,	NULL,	NULL,	NULL,
	""
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "threads_max",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_max_threads),	sizeof(uint),
	SM_XSTR(THREADS_DEFAULT_MAX),	0,	NULL,	NULL,	NULL,
	"maximum number of threads"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "wait_threads_max",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_max_wait_threads),	sizeof(uint),
	SM_XSTR(WAIT_THREADS_DEFAULT_MAX),	0,	NULL,	NULL,	NULL,
	"maximum number of waiting threads"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "wait_threads_min",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_min_wait_threads),	sizeof(uint),
	SM_XSTR(WAIT_THREADS_DEFAULT_MIN),	0,	NULL,	NULL,	NULL,
	"minimum number of waiting threads"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "flags",		sm_conf_type_choice,
	offsetof(sc_cnf_T, sc_cnf_cflags),	sizeof(uint32_t),
	NULL, SM_CONF_FLAG_KEEP_DEFAULT|SM_CONF_FLAG_MULTIPLE|SM_CONF_FLAG_OR|SM_CONF_FLAG_PLURAL,
	sc_flag_names,
	NULL,	NULL,
	"flags to influence behavior [see documentation]"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "log_level",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_loglevel),	sizeof(uint),
	SM_XSTR(SM_LOG_LEVEL),	0 /* SM_CONF_FLAG_DPRCD */,	NULL,	NULL,	NULL,
	""
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },
{ SM_CONF_DEF_MAGIC, "log", sm_conf_type_section,
	offsetof(sc_cnf_T, sc_cnf_log),		0,
	NULL, SM_CONF_FLAG_KEEP_DEFAULT, sm_log_spec_defs,
	NULL, NULL, NULL
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "debug_level",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_debug),	sizeof(int),
	"0",	0,	NULL,	NULL,	NULL,
	NULL
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "io_timeout",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_timeout),	sizeof(sm_intvl_T),
	SM_XSTR(SC_IO_TIMEOUT),	0,	sm_conf_time_suffixes,
	NULL,	NULL,
	"timeout for SMTP I/O operations"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "module_timeout",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_qmgr_tmo),	sizeof(sm_intvl_T),
	SM_XSTR(SC_RCB_SND_TMO),	0,	sm_conf_time_suffixes,
	NULL,	NULL,
	"timeout for communication with other modules (QMGR)"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "wait_for_server",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_wait4srv),	sizeof(uint),
	"1",			0,	sm_conf_time_suffixes,
	NULL,	NULL,
	"maximum amount of time to wait for a server to become available"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "id",			sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_id),		sizeof(uint),
	SM_XSTR(SMTPC_ID),	SM_CONF_FLAG_KEEP_DEFAULT,
	NULL,	NULL,	NULL,
	"unique id"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "connect_only_to",		sm_conf_type_ip,
	offsetof(sc_cnf_T, sc_cnf_sink),	sizeof(sm_ipaddr_T),
	NULL,			0,	0,
	NULL,	NULL,
	"connect only to this IP address [testing]"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

#if FFR_CLIENT_BIND
{ SM_CONF_DEF_MAGIC, "clientaddr",		sm_conf_type_ip,
	offsetof(sc_cnf_T, sc_cnf_bind),	sizeof(sm_ipaddr_T),
	NULL,			0,	0,
	NULL,	NULL,
	"bind() to this local IP address"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },
#endif

#if MTA_USE_TLS
{ SM_CONF_DEF_MAGIC, "tls", sm_conf_type_section,
	offsetof(sc_cnf_T, sc_cnf_tls), sizeof(sc_cnf_T), NULL,
	SM_CONF_FLAG_KEEP_DEFAULT|SM_CONF_FLAG_MULTIPLE,
	tls_defs,
	NULL, NULL, NULL
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },
#endif /* MTA_USE_TLS */

#if SC_TEST
{ SM_CONF_DEF_MAGIC, "tests",		sm_conf_type_u32,
	offsetof(sc_cnf_T, sc_cnf_tests),	sizeof(uint),
	"0", 0, NULL, NULL, NULL,
	"test options"
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },
#endif

#if SC_SESS_FEATS
{ SM_CONF_DEF_MAGIC, "session_features",		sm_conf_type_array,
	0,	/* offset */
	0,	/* size (# of elements) */
	NULL,	/* default */
	SM_CONF_FLAG_MULTIPLE|SM_CONF_FLAG_PLURAL,
	sc_se_feat_definitions,
	NULL,  NULL,
	"session feature declarations"
	SM_LC_NO_ISSET	SM_LC_SET_MAGIC(0) },
#endif /* SC_SESS_FEATS */

	MCP_DEFS(sc_cnf_T, sc_cnf)

CONF_SENTINEL
}
#endif /* SM_SCCNFDEF */
;

EXTERN
sm_conf_definition_T
sc_global_defs[]
#if SM_SCCNFDEF
=
{
{ SM_CONF_DEF_MAGIC, "SMTPC_socket",	sm_conf_type_string,
	offsetof(sc_cnf_T, sc_cnf_smtpcsock),	0,	smsmtpcsock,
	0, NULL, NULL, NULL, NULL
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },
{ SM_CONF_DEF_MAGIC, "CDB_base_directory",	sm_conf_type_string,
	offsetof(sc_cnf_T, sc_cnf_cdb_base),	0,	"",
	0, NULL, NULL, NULL, NULL
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },
{ SM_CONF_DEF_MAGIC, "hostname",		sm_conf_type_string,
	offsetof(sc_cnf_T, sc_cnf_hostname),	0,	NULL,
	0, NULL, NULL, NULL, NULL
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

{ SM_CONF_DEF_MAGIC, "smtpc", sm_conf_type_section,
	0, sizeof(sc_cnf_T), NULL,
	SM_CONF_FLAG_KEEP_DEFAULT|SM_CONF_FLAG_MULTIPLE|SM_CONF_FLAG_PARSE_ONLY,
	sc_defs,
	NULL, NULL, NULL
	SM_LC_NO_ISSET SM_LC_SET_MAGIC(SM_SC_CNF_MAGIC) },

CONF_SENTINEL
}
#endif /* SM_SCCNFDEF */
;

#undef EXTERN

#endif /* SM_SCCNFDEF_H */
