#!/bin/sh
# $Id: t-dnstcp-0.sh,v 1.2 2013/12/29 01:28:34 ca Exp $
#
# ----------------------------------------
# test TCP timeout/reconnect handling
# ----------------------------------------
#

if test X"${MTA_NO_DNS_TEST}" != "X" -o  X"${MTA_NO_SLOW_TEST}" != "X"
then
  echo "SKIPPED: $0"
  exit 0
fi

#
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../
fi
. ${SD}/common.sh

TPRG=./t-dnstsk-0
rm -f $OUT

# trigger timeout?
H1=host1.meta1.org
H2=host2.meta1.org
./t-dnstsk-1 -i ${NS} -e 10 -S 1 -s 40 -t 50 -a -VVVVV -T -m $H1 $H2 >$OUT 2>&1
if fgrep '[10.0.0.1]' $OUT >/dev/null
then
  :
else
  echo "$0: missing 10.0.0.1"
  exit 1
fi
if fgrep '[10.0.0.2]' $OUT >/dev/null
then
  :
else
  echo "$0: missing 10.0.0.2"
  exit 1
fi

rm -f $OUT
exit 0
