/*
 * Copyright (c) 2014 Claus Assmann
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the license/LICENSE.3C file which can be found at the
 * top level of this source code distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: tlsnotafter.c,v 1.1 2014/01/11 18:16:22 ca Exp $")
#include "sm/time.h"
#include "sm/memops.h"
#include "sm/tlsmisc.h"

#if MTA_USE_TLS

time_T
ASN1_GetTimeT(ASN1_TIME *asn1_time)
{
    struct tm t;
    const char *str;
    char *next;

    sm_memzero(&t, sizeof(t));
    str = (const char *) asn1_time->data;
	next = NULL;
    if (asn1_time->type == V_ASN1_UTCTIME)
        next = strptime(str, "%y%m%d%H%M%S", &t);
    else if (asn1_time->type == V_ASN1_GENERALIZEDTIME)
        next = strptime(str, "%Y%m%d%H%M%S", &t);
	if (NULL == next)
		return (time_T)-1;
    return mktime(&t);
}

time_T
notafter(X509 *x509)
{
	return ASN1_GetTimeT(X509_get_notAfter(x509));
}

#endif /* MTA_USE_TLS */
